C     Last change:  CWM  22 Nov 1999    1:07 pm
      SUBROUTINE CULV1(NPROG)
      INCLUDE 'INCLUDE.fi'
      REAL*8 QTRY(0:50),XTRY(0:50)
      REAL*8 HSTRI(50),A1NTRY(50)
      REAL*8 A1NMAX,A1NMIN,QMAX,QMIN,QQMAX,DAEST
      REAL*8 F1SQ,F2SQ,TRY,Q1SQ,Q2SQ
      REAL*8 U1S,U1N,U2N,DA,DA1,DA2,FLHS,DADX,DA2DX
      REAL*8 DA1DX,DX1,DX2,DXBAR,HSTRY
      REAL*8 TOTHEADBAR
      INTEGER*4 NA,IA1N,NQ,IQ1,IA1S,NDA1,IX,IDX
      INTEGER*4 JQMAX,NPROG
C     OPEN(UNIT=8,FILE='CULV.DPT',STATUS='UNKNOWN')
      NPROG = 1
      XTRY(0)=0.0D0
      CUL1 = 1.0D0
C     WRITE(6,20)
C  20 FORMAT(/' COMPUTATION FOR TWO LAYER FLOW --'/)
      GO TO 46
   45   print *,'S45/Q SET TO PREVIOUS VALUE: CULV1'
        Q1=Q1PREV
        Q2=Q2PREV
      RETURN
   46 CONTINUE
      G = 32.2
C     DO IA1N LOOP IS FOR TRIAL VALUES OF A1N. TRIAL VALUES ARE
C     SELECTED AS AVERAGE OF MAX AND MIN.
      A1NMAX = MIN(HEIGHT,HN*RHO2/RHO1)
      A1NMIN = 0.
      NA = 0
      DO IA1N = 1,50
        A1N = MIN(HEIGHT,0.5*(A1NMAX + A1NMIN))
C       DO IQI LOOP IS FOR TRIAL VALUES OF Q1. FIRST TWO TRIAL VALUES ARE
C       SELECTED AS AVERAGE OF MAX AND MIN. AFTER THAT, LAST TWO RESULTS ARE
C       EXTRAPOLATED TO GET NEXT TRIAL.
C       QMAX (WHICH IS ACTUALLY Q1MAX) IS BASED ON A DENSIMETRIC FROUDE
C       NUMBER OF UNITY IN THE UPPER LAYER AT THE NORTH END.
        QMAX = CHNW*A1N*SQRT(EPS*G*A1N)
        QMAX = CHNW*A1N*SQRT(EPS*G*A1N)
        QQMAX = QMAX
        QMIN = 0.
        DAEST=0.0D0
        NQ = 0
        DO IQ1 = 1,25
          Q1 = 0.5  *(QMAX + QMIN)
C CALCULATE Q2 AND A2N FOR TRIAL Q1 AND A1N.
          F1SQ = Q1*Q1/(CHNW*CHNW*EPS*G*A1N**3)
          F2SQ = (1. - F1SQ)/(1. - EPS*F1SQ)
C IF (F2SQ .LE. 0.), THEN THE TRIAL Q1 IS TOO LARGE.
          IF (F2SQ .LE. 0.0)THEN
            QMAX = Q1
            Q1 = 0.5*(QMAX + QMIN)
            GO TO 300   !CYCLE
          ENDIF
C     IF F2SQ IS GT F1SQ THEN TRIAL Q1 IS TOO SMALL
          IF (F2SQ.GE.F1SQ) THEN
            QMIN=Q1
            Q1=0.5*(QMAX+QMIN)
            GO TO 300   !CYCLE
          ENDIF
          NQ = NQ + 1
C A2N IS CALCULATED USING ENERGY EQUATION BETWEEN NORTH LAKE AND LOWER
C LAYER ENTRANCE. THIS ASSUMES THAT ALL OF THE ENTRANCE LOSS IS INSIDE
C THE CULVERT AFTER THE ENTRANCE.
          A2N = (HN - RHO1*A1N/RHO2)/(1. + 0.5*EPS*F2SQ)
          TOTHEAD1=(HN-(Q2/(CHNW*A2N))**2/(2.0D0*G)-
     -      EPS*A2N)/(1.0D0 - EPS)
          IF(TOTHEAD1.GT.HEIGHT)THEN
            A2N=MAX(0.0D0,HEIGHT-A1N)
            TOTHEAD1=(HN-(Q2/(CHNW*A2N))**2/(2.0D0*G)-
     -        EPS*A2N)/(1.0D0 - EPS)
          ENDIF
C Q2 IS CALCULATED FROM THE DEFINITION OF F2SQ.
          Q2 = - SQRT(F2SQ*CHNW*CHNW*EPS*G*A2N**3)
C         Unsubmerged conditions assumed in the following calculations
C     WRITE (1,8001) Q1,Q2,A2N,AN,FLHSN,F2,F1SQ,F2SQ
C8001 FORMAT ('   Q1=',F10.0,'    Q2=',F10.0,'   A2N=',F10.1,'    AN=',
C    -F10.1,/,'FLHSN=',F10.2,'    F2=',F10.2,'  F1SQ=',F10.2,'  F2SQ=',
C    2F10.2)
C DETERMINE APPROX VALUES OF A1S AND A2S ASSUMING AS = AN PLUS
C ELEVATION CHANGE (DAEST) ESTIMATED FROM PREVIOUS TRIAL. THE
C CALCULATION IS BASED ON CRITICAL CONDITION AT THE SOUTH END OF THE
C CULVERT.
          Q1SQ = Q1*Q1
          Q2SQ = Q2*Q2
          A2S=((Q2*F2SQ*EPS*G)**2*CHNW)
     -      **(1.0D0/3.0D0)/(F2SQ*CHNW*EPS*G)
          A1S=HS-A2S
          DO IA1S = 1,25
            TRY=A2S
            A2S=1.0D0/(F2SQ*CHNW*EPS*G)*
     +        (Q2SQ*F2SQ**2*CHNW*EPS**2*G**2)**(1./3.)
            A1S = HS - A2S - Q1SQ
     +        /(CHNW*A1S)**2/(2.*G)
            F1SQ=(Q1/(CHNW*A1S))**2/(EPS*G*A1S)
            F2SQ=(F1SQ-1.0D0)/(-1.0D0+EPS*F1SQ)
            IF(IA1S.GT.1.AND.ABS(TRY-A2S) .LT.0.0001) GO TO 160 !EXIT
          ENDDO
  160     CONTINUE
C         If submerged conditions exist, redo south end calculations
C         for submerged conditions.
          IF(A1S+A2S.GT.HEIGHT)THEN
            DO IA1S = 1,25
              TRY=A2S
              A2S=1.0D0/(F2SQ*CHNW*EPS*G)*
     +          (Q2SQ*F2SQ**2*CHNW*EPS**2*G**2)**(1./3.)
              A1S = HEIGHT - A2S
              U1S=Q1/(CHNW*A1S)
              F1SQ=U1S**2/(EPS*G*A1S)
              F2SQ=(F1SQ-1.0D0)/(-1.0D0+EPS*F1SQ)
              IF(IA1S.GT.1.AND.ABS(TRY-A2S) .LT.0.0001) GO TO 170 !EXIT
            ENDDO
  170       CONTINUE
          ENDIF
C     WRITE(6,175) IA1S
C 175 FORMAT(1X, 'IA1S =', I5  )
C     WRITE (1,8002) A1S,A2S,TRY
C8002 FORMAT ('  A1S=',F10.2,'   A2S=',F10.2,'   TRY=',F10.2)
C CALCULATE ENERGY SLOPES FOR EQUIVALENT LOSS TO REPLACE ENTRANCE LOSS.
C FOR LOWER LAYER, PREVIOUS APPROX VALUE OF A1S MUST BE USED.
          U1S = Q1/(A1S*CHNW)
          SENTR1 = ENTRS*U1S*U1S/(2.*G*FL)
          U1N = Q1/(A1N*CHNW)
          U2N = Q2/(A2N*CHNW)
          SENTR2 = ENTRN1*U2N*U2N/(2.*G*FL)
     A       + ENTRN2*(U1N - U2N)**2/(2.*G*FL)
C PERFORM INTEGRATION FROM NORTH TO SOUTH TO OBTAIN FLOW LENGTH TO
C CRITICAL CONDITION. DO 260 LOOP DOES THIS INTEGRATION. THE CRITICAL
C CONDITION IS GIVEN BY FLHS = 1.
          A1 = A1N
          A2 = A2N
          X = 0.
          DA = 0.
          DA1 = DELA1
          NDA1 = 1
          DA2 = DA - DA1
          TOTHEAD1=(HN-(Q2/(CHNW*A2N))**2/(2.0D0*G)-
     -      EPS*A2N)/(1.0D0 - EPS)
C     WRITE (1,8003) DA1,DA2,A1,A2
C8003 FORMAT ('  DA1=',F10.2,'   DA2=',F10.2,'    A1=',F10.2,'    A2=',
C    -F10.2)
C     REWIND(8)
          DO IX = 1,300    ! A1calc LOOP
C            WRITE(17,*)'ENTERING A1CALC LOOP' 
            A1BAR = A1 + 0.5*DA1
C     WRITE(8,185)-X,A1+A2,A2
C 185 FORMAT(1X,3F10.2)
            A1BAR = A1 + 0.5*DA1
C           DO IDX LOOP FINDS DX FOR GIVEN DA1 BY TRIAL.
            DO IDX = 1,25
C              WRITE(17,*)'ENTERING CULV1 IDX LOOP'
              A2BAR = A2 + 0.5*DA2
              F1SQ = Q1*Q1/(CHNW*CHNW*EPS*G*A1BAR**3)
              F2SQ = Q2*Q2/(CHNW*CHNW*EPS*G*A2BAR**3)
              FLHS = F1SQ + F2SQ - EPS*F1SQ*F2SQ
              NSTOP = 0
              IF(F2SQ.LT.-2.3)STOP
c      IF(F2SQ.LT.-2.3)WRITE(*,*)Q1,'=Q1 ',Q2,'=Q2 ',EPS,'=EPS ',
C     - A1BAR,'=A1BAR ',A2BAR,'=A2BAR ',CHNW,'=CHNW ',G,'=G'
C     WRITE (1,8004) F1SQ,F2SQ,FLHS
C8004 FORMAT (' F1SQ=',F10.2,'  F2SQ=',F10.2,'  FLHS=',F10.2,
C    -' CALLING SLOPE')
C              WRITE(17,*)'CALLING SLOPE SUB'
              CALL SLOPE(DA1DX,DA2DX,DADX)
C IF(DENOM .EQ. 0.), THEN NSTOP IS SET EQUAL TO 1 AND DA1 IS REDUCED
C TO HALF OF THE PREVIOUS VALUE FOR REMAINDER OF INTEGRATION
C WITH RESPECT TO X.
              IF(NSTOP .EQ. 1)THEN
                DA1 = 0.5*DA1
                GOTO 260   !CYCLE A1calc
              ENDIF
C     WRITE (1,8005) NSTOP,DENOM,U1BAR,U2BAR,A1BAR,A2BAR
C8005 FORMAT ('NSTOP=',F10.2,' DENOM=',F10.2,' U1BAR=',F10.2,' U2BAR=',
C    -F10.2,/,'A1BAR=',F10.2,' A2BAR=',F10.2)
              DX1 = DA1/DA1DX
              DX2 = DA2/DA2DX
              DXBAR = 0.5*(DX1 + DX2)
              TOTHEADBAR=TOTHEAD1+DADX*DXBAR/2.0D0
              IF(TOTHEADBAR.GT.HEIGHT) then
                DA=0.0D0
              ELSE
                DA = DADX*DXBAR
              ENDIF
C     WRITE (1,8006) ABS(DX1-DX2)
C8006 FORMAT ('ABSDX=',F10.2)
              DA2 = DA - DA1
              IF(ABS(DX1 - DX2) .LT. TOLDX.OR.
     1          (TOTHEADBAR.GT.HEIGHT.AND.IDX.GT.2))GO TO 230
            ENDDO
            GO TO 45
C     WRITE(6,226) IDX
C 226 FORMAT ( ' IDX =', I5  )
  230       CONTINUE
            TOTHEAD1=TOTHEAD1+DADX*DX1
            IF(TOTHEAD1.GT.HEIGHT)THEN
              A2=A2 + DA2
              A1=HEIGHT-A2
            ELSE
              A1 = A1 + DA1
              A2 = A2 + DA2
            ENDIF
C BEGIN REVISION 3/2/93
C IF CONDITION IS NOT TWO LAYER FLOW: RETURN TO CULV2
            IF(A2.LE.0.0)THEN
              NPROG=2
              RETURN
            ENDIF
C END REVISION 3/2/93
            F1SQ = Q1*Q1/(CHNW*CHNW*EPS*G*A1 **3)
            F2SQ = Q2*Q2/(CHNW*CHNW*EPS*G*A2 **3)
            FLHS = F1SQ + F2SQ - EPS*F1SQ*F2SQ
            X = X + DXBAR
C     WRITE (1,8007) A1,A2,F1SQ,F2SQ,FLHS,X
C8007 FORMAT ('   A1=',F10.2,'    A2=',F10.2,'  F1SQ=',F10.2,'  F2SQ=',
C    -F10.2,/,' FLHS=',F10.2,'     X=',F10.2)
C 250 FORMAT (1X, F13.2, 3F14.3, 3F14.4 ,2I10)
C IF (FLHS .LT. 1.), THEN CRITICAL CONDITION AT SOUTH END HAS NOT YET
C BEEN REACHED AND INTEGRATION MUST CONTINUE.
            IF (FLHS .LT. 1.0) GO TO 260  !CYCLE
C IT IS NOT POSSIBLE TO OBTAIN EXACTLY FLHS = 1. THE FIRST TIME THAT
C FLHS .GT. 1. IS OBTAINED, THE INTEGRATION BACKS UP ONE STEP AND
C REDUCES DA1 BY A FACTOR OF 10. THE NEXT TIME THAT FLHS .GT. 1. IS
C OBTAINED THE INTEGRATION STOPS. THIS ALLOWS A CLOSER APPROX TO
C FLHS = 1. WITHOUT HAVING TO USE SMALL DA1 THROUGHOUT THE INTEGRATION.
            IF (FLHS .GE. 1.0 .AND. NDA1 .EQ. 2) GO TO 275
            NDA1 = 2
            A1 = A1 - DA1
            A2 = A2 - DA2
            X = X - DXBAR
            DA1 = 0.1*DA1
 260        CONTINUE   
          ENDDO         ! A1calc
C     WRITE(6,265)  IX
C 265 FORMAT(  ' IX =', I5   )
          GO TO 45
  275     CONTINUE
C STORE THE TRIAL VALUE OF Q1 AND THE CORRESPONDING VALUE OF X AT THE
C END OF THE INTEGRATION FOR EXTRAPOLATION FOR NEW TRIAL Q1.
          QTRY(NQ ) = Q1
          XTRY( NQ) = X
C ADJUST QMAX AND QMIN BASED ON LAST X RELATIVE TO FL.
          IF(-X .GE. FL)THEN
            QMAX = Q1
          ELSE
            QMIN = Q1
          ENDIF
C     WRITE (1,8008) QTRY(NQ),XTRY(NQ),-X,QMAX,QMIN
C8008 FORMAT (' QTRY=',F10.2,'  XTRY=',F10.2,'    -X=',F10.2,
C    -/,' QMAX=',F10.2,'  QMIN=',F10.2)
C FOR FIRST TRIAL Q1 SKIP EXTRAPOLATION PROCEDURE.
          IF(NQ  .EQ. 0) GO TO 300 !CYCLE
C IF BOTH INTEGRATED LENGTH AND Q1 ARE WITHIN ERROR BOUNDS, THEN STOP
C ITERATING Q1 VALUES.
          IF (ABS(FL + X) .LE. TOLX .AND. ABS(QTRY(NQ ) - QTRY(NQ -1))
     A                     .LT. TOLQ1) GO TO 350
C IT IS POSSIBLE FOR TRIAL A1N TO BE SO LARGE AND CORRESPONDING QMAX
C TO BE SO LARGE THAT IT IS IMPOSSIBLE TO FIND A Q1 FOR WHICH THE INTE-
C GRATED LENGTH EQUALS FL. IF THIS HAPPENS THEN ADJUST THE A1N VALUE.
          JQMAX = 0
          IF ((QQMAX-Q1).LT.0.01*CHNW.AND.(-X).LT.FL) GO TO 345
          IF(ABS(XTRY(NQ)-XTRY(NQ-1)).GT.1.0D-10) GO TO 300 !CYCLE 
C     WRITE(6,296)
C 296 FORMAT(/' XTRY(NQ) = XTRY(NQ-1)'  /  )
C     WRITE(6,297)  (XTRY(J), J=1,IQ1)
C     WRITE(6,297)  (QTRY(J), J=1,IQ1)
C 297 FORMAT(1X,10F12.6)
          GO TO 45
  300     CONTINUE
        ENDDO 
        GO TO 45
  345   CONTINUE
C     WRITE(6,310)  IQ1
C 310 FORMAT (  ' IQ1 =', I5  )
C     WRITE (1,8009) QQMAX,Q1
C8009 FORMAT ('QQMAX=',F10.2,'    Q1=',F10.2)
        JQMAX = 1
  350   CONTINUE
C     WRITE (1,8010) ABS(QTRY(NQ)-QTRY(NQ-1))
C8010 FORMAT ('ABSQT=',F10.2)
C 360 FORMAT(  /   ' Q1 = ',F10.1,10X, 'Q2 = ',F10.1   /  /
C    1       11X, 'X', 13X, 'A', 12X, 'A1', 12X, 'A2',11X, 'LHS',12X,
C    2                  'F1', 12X, 'F2'     )
C HSTRY IS THE VALUE OF HS CORRESPONDING TO THE VALUE OF AS WHICH
C RESULTED FROM TRIAL A1N.
        HSTRY = TOTHEAD1 + Q1*Q1/(CHNW*CHNW*A1*A1*2.0*G)
C     WRITE (1,8011) HSTRY
C8011 FORMAT ('HSTRY=',F10.2)
        IF(JQMAX .NE. 1)THEN
C STORE THE TRIAL VALUE OF A1N AND THE CORRESPONDING HSTRY FOR
C EXTRAPOLATION TO NEW TRIAL A1N.
C IF (ABS(HSTRY - HS) .LT. TOLHS) THEN STOP THE ITERATION. THIS GIVES
C THE FINAL VALUES.
C     WRITE (1,8012) NA,A1NTRY(NA),HSTRI(NA),ABS(HSTRY-HS)
C8012 FORMAT ('   NA=',F10.2,' A1NTRY=',F10.2,' HSTRI=',F10.2,
C    -'ABS(HSTRY-HS)=',F10.2)
          IF(ABS(HSTRY - HS) .LT.TOLHS ) GO TO 450
          IF(HSTRY .LT. HS) A1NMIN = A1N
          IF(HSTRY .GT. HS) A1NMAX = A1N
        ELSE
          A1NMAX = A1N
          A1N = 0.5*(A1NMAX + A1NMIN)
        ENDIF
  400   CONTINUE
      ENDDO
      GO TO 45
  450 CONTINUE
      RETURN
      END
C IF(NA   .GE. 2) THEN GO TO EXTRAPOLATION FOR NEW TRIAL A1N.
C OTHERWISE, ADJUST MAX OR MIN VALUE AND TAKE AVERAGE OF MAX AND MIN.
C     WRITE (1,8013) (HSTRY-HS)
C8013 FORMAT ('HSTRY-HS=',F10.2)
C     WRITE (1,8014) A1N
C8014 FORMAT ('  A1N=',F10.2)
C     WRITE(6,410)  IA1N
C 410 FORMAT(  ' IA1N =',  I5  )
C     WRITE(6,360) Q1, Q2
C     WRITE(6,250) XN,AN,A1N,A2N,FLHSN,F1 ,F2
C     F1 = SQRT(F1SQ)
C     F2 = SQRT(F2SQ)
C     WRITE(6 , 250)  X, A, A1, A2 , FLHS, F1, F2
C     WRITE(6,491)
C 491 FORMAT(/' TWO LAYER FLOW IS THE CORRECT FLOW REGIME.' /)
C      WRITE(*,*)'TWO LAYER FLOW: CULV1'






