C     Last change:  CWM   8 Nov 1999    7:53 am
      SUBROUTINE CULV2A(NPROG)
      INCLUDE 'INCLUDE.fi'
C THIS SUBROUTINE ASSUMES AN ARRESTED WEDGE.
C     REAL   NW1,NW2,NI,NZ
C     COMMON /BLK1/ Q1,Q2,CHNW,EPS,NZ,NI,NW1,NW2,RHO1,RHO2,G,SZ,
C    -   A1BAR,A2BAR,
C    -   HEIGHT,
C    A   DENOM,NSTOP,SENTR1,SENTR2,X,FL,TT1,TT2,TT3,TT4,
C    -   TT8,TT9,FCOEF
C     INTEGER (KIND=4) NSTOP
C     REAL (KIND=8) Q1,Q2,CHNW,EPS,RHO1,RHO2,G,SZ
C     REAL (KIND=8) A1BAR,A2BAR,DENOM,SENTR1,SENTR2,X,FL,HEIGHT
C     REAL (KIND=8) TT1,TT2,TT3,TT4,FCOEF,TT8,TT9
C     COMMON /BLK2/ TOLX,TOLDX,TOLQ1,TOLHS,DELA1,HS,HN
C    A  , ENTRS,ENTRN1,ENTRN2
C     REAL (KIND=8) TOLX,TOLDX,TOLQ1,TOLHS,DELA1,HS,HN
C     REAL (KIND=8) ENTRS,ENTRN1,ENTRN2
C     COMMON /BLK4/ CUL1
      REAL*8 EGL(40),XTRY( 40)
      REAL*8 QMIN,TRY,PHEADN,PHEAD2,U2N
      REAL*8 QMAX,AS,AN,FLHSN,EGLN,DA,DA1,DA2,DADX
      REAL*8 DA2DX,DA1DX,DX1,DX2,DXBAR,F2SQ,COEF,U1S
      REAL*8 PHEADBAR,U2,FR2SQ,RW2,RZ,FW2,FZ,TAUE2,TAUW2
      REAL*8 RT,FT,TAUT,DX,TAUZ
      INTEGER*4 IQ1,IAS,NPROG,NSTEP,NDA2,IX,IDX
C     WRITE(6,35)
C  35 FORMAT(/' COMPUTATION FOR AN ARRESTED WEDGE --' / )
C      IF (PRINTIT) THEN
C        WRITE(17,*)' IN CULV2A'
C        WRITE(17,*)' TT1  ',TT1,' TT2   ',TT2   ,'  TT3  ',TT3,
C     A   ' TT4   ',TT4
C        WRITE(17,*)' TT7  ',TT7,' TT8   ',TT8   ,'  TT9  ',TT9,
C     A   ' HN    ',HN
C        WRITE(17,*)' HS   ',HS ,' RHO1  ',RHO1  ,'  RHO2 ',RHO2,
C     A   ' CNHW  ',CHNW
C         WRITE(17,*)' FL   ',FL ,' ENTRN1',ENTRN1,'  ENTRS',ENTRS
C      END IF
C      XTRY=0.0D0
C      EGL=0.0D0
      G = 32.2
      NSTEP = 25
      IF(HN.LT.HEIGHT)THEN
        NPROG=1
        RETURN
      ENDIF
      NDA2 = NSTEP
C QMAX IS BASED ON F1 = 1 AT SOUTH END WITH MAXIMUM POSSIBLE A2N.
      A2S = DMIN1(HN,HEIGHT)
      QMAX = CHNW*A2S*SQRT(EPS*G*A2S)
      QMIN = 0.
      DO IQ1 = 1,25    !QLOOP
        Q2 = 0.5*(QMAX + QMIN)
C FOR TRIAL Q1, F1 MUST BE UNITY AT NORTH END. A1N IS CALCULATED FROM
C THIS FACT. A2N IS THEN OBTAINED BY HYDROSTATICS.
C     F1SQ = 1.
        A2S = DMIN1(HEIGHT,(Q2**2/(CHNW**2*EPS*G))
     1    **(1./3.))
        A1S = DMAX1(0.0D0,DMIN1(HS,HEIGHT) - A2S)
C FOR ARRESTED WEDGE, Q2 = 0.
        Q1 = 0.
C DETERMINE DEPTH (A1S) JUST INSIDE OF CULVERT ACCOUNTING FOR
C VELOCITY HEAD. A1SMIN IS BASED ON CRITICAL DEPTH.
        A2N = (Q2*Q2/(CHNW*CHNW*G))**0.333333
        A1N = 0.0D0
        DO IAS = 1,25
          TRY=A2N
          A2N = DMIN1(HEIGHT,HN-Q2*Q2/(CHNW*CHNW*2.*G*TRY*TRY))
          IF (ABS(A2N - TRY) .LE. 0.00001) GO TO 1010
        ENDDO
C     WRITE (6,1006) IAS
C1006 FORMAT ( ' IAS =', I5  )
        NPROG = 2
*      WRITE(*,*)'ARRESTED WEDGE: CULV2.1'
        RETURN
 1010   CONTINUE
        TOTHEAD1=HS
        PHEADN=HN-(Q2/(CHNW*A2N))**2/(2.0*G)
        PHEAD2=RHO1/RHO2*HS+EPS*A2S
        U2N = Q2/(A2N*CHNW)
C SENTR IS THE ENERGY SLOPE RESULTING FROM UNIFORM DISTRIBUTION
C OF THE ENTRANCE LOSS ALONG THE LENGTH OF THE CULVERT.
        SENTR2 = ENTRN1*U2N*U2N/(2.*G*FL)
        SENTR1 = 0.
        AS = A2S + A1S
C PERFORM INTEGRATION FROM NORTH TO SOUTH TO OBTAIN FLOW LENGTH TO
C MATCH HS. FROM NORTH END TO TOE OF WEDGE, INTEGRATION (DO 260 LOOP)
C MUST BE DONE AS A STRATIFIED FLOW COMPUTATION AS IN CULV1. UPSTREAM
C OF TOE, INTEGRATION (DO 1100 LOOP) IS AS IN CULV3 FOR SINGLE LAYER
C FLOW.
        A1 = A1S
        A2 = A2S
        X = 0.
        XTRY(1) = 0.0D0
        IF(A1S.GT.0.0D0)THEN
          EGLN = TOTHEAD1
          EGL(1) = EGLN
          IX = 0
          IF(EGLN .GT. HS  )THEN
            QMAX = Q2
            GO TO 300   !CYCLE QLOOP
          ENDIF
          DA = 0.
          DA1 = -A1S/NDA2
          DA2 = DA - DA1
          DO IX = 1,NDA2        !INTEGER LOOP
            A1BAR = A1 + 0.5*DA1
C FIND DX FOR GIVEN DA2 BY TRIAL.
            DO IDX = 1,25
              A2BAR = A2 + 0.5*DA2
              DENOM = 1.0
C             F1SQ = Q1*Q1/(CHNW*CHNW*EPS*G*A1BAR**3)
C             FLHS = F1SQ
C      WRITE(*,*)F1SQ,'=F1SQ  ',F2SQ,'=F2SQ  ',FLHS,'=FLHS  CALL SLOPE'
              CALL SLOPE(DA1DX,DA2DX,DADX)
              DX1 = -DA1/DA1DX
              DX2 = -DA2/DA2DX
              DXBAR = 0.5*(DX1 + DX2)
              IF(TOTHEAD1.GE.HEIGHT)THEN
                DA=0.0
              ELSE
                DA = DADX*DXBAR
              ENDIF
              DA1 = DA - DA2
              IF(ABS(DX1 - DX2) .LT. TOLDX.OR.(IDX.GT.2.AND.(
     1          Q1.EQ.0.0D0.OR.Q2.EQ.0.0D0)))GO TO 230
            ENDDO
C     WRITE(6,226) IDX
C 226 FORMAT ( ' IDX =', I5  )
            NPROG = 2
*      WRITE(*,*)'ARRESTED WEDGE: CULV2.2'
            RETURN
  230       CONTINUE
            TOTHEAD1=TOTHEAD1 + DADX*DX1
            IF(TOTHEAD1.GT.HEIGHT)THEN
              A2 = DMIN1(HEIGHT,A2 + DA2)
              A1 = DMAX1(0.0D0,HEIGHT-A2)
            ELSE
              A1 = A1 + DA1
              A2 = A2 + DA2
            ENDIF
            F2SQ = Q2*Q2/(CHNW*CHNW*EPS*G*A2 **3)
C           FLHS = F2SQ
            X = X + DXBAR
            XTRY(IX+1) = X
            PHEAD2=TOTHEAD1*RHO1/RHO2+A2*EPS
            EGL(IX+1) = PHEAD2 + Q2*Q2/
     +        (CHNW*CHNW*A2*A2*2.0*G)
C IF (EGL .LT. HS), THEN PROCEED WITH INTEGRATION. OTHERWISE, STOP
C AND INTERPOLATE TO FIND X CORRESPONDING TO EGL = HS.
            IF(EGL(IX+1) .LT.  HN  ) GO TO 240 !CYCLE integr
            COEF = (HN - EGL  (IX  ))/(EGL  (IX+1) - EGL  (IX  ))
            X = XTRY(IX  ) + COEF*(XTRY(IX+1) - XTRY(IX  ))
C IF EGL = HS BEFORE TOE OF WEDGE IS REACHED, THEN SKIP DO 1100 LOOP.
            GO TO 278
 240        CONTINUE    
          ENDDO    !INTEGER LOOP
        ENDIF
C DETERMINE LENGTH FOR DEPTH TO CHANGE FROM A2 TO A2N OR DEPTH OF CULVERT.
        IF (PHEADN.GT.PHEAD2) THEN
          DA2 = (PHEADN - PHEAD2)/NSTEP
          A1BAR = 0.
          A1 = 0.
          DO IAS =1,NSTEP
            PHEADBAR = PHEAD2 + 0.5*DA2
            A2BAR=DMIN1(PHEADBAR,HEIGHT)
            U2 = Q2/(CHNW*A2BAR)
            FR2SQ = U2*U2/(G*A2BAR)
C ALLOCATE TOTAL RESISTANCE TO VARIOUS SHEAR SURFACES IN ORDER TO
C CONVERT FROM N TO F.
            IF(PHEADBAR.LT.HEIGHT)THEN
              RW2=CHNW*A2BAR/(2.*A2BAR+CHNW*TT2*TT4)
              RZ =CHNW*A2BAR/(2.*A2BAR/(TT2*TT4)+CHNW)
              FW2 = 116.7*NW1(ICHN)*NW1(ICHN)/RW2**0.333333
              FZ = 116.7*NZ(ICHN)*NZ(ICHN)/RZ**0.333333
              TAUE2 = G*RHO2*CHNW*A2BAR*SENTR2/(CHNW + 2.*A2BAR)
              TAUW2 = FW2*RHO2*ABS(U2)*U2/8.
              TAUZ  = FZ*RHO2*ABS(U2)*U2/8.
              DENOM=(TAUZ+TAUE2+2.*A2BAR*(TAUW2+TAUE2)/CHNW)/
     +          (G*RHO2*A2BAR)
            ELSE
              RW2=A2BAR*CHNW/(2*A2BAR+CHNW*(TT3+TT8))
              RZ=A2BAR*CHNW/(2.0D0/TT3+CHNW*(1.0D0+TT9))
              RT=A2BAR*CHNW/(2.0D0/TT8+CHNW*(1.0D0+1.0D0/TT9))
              FW2=116.7*NW1(ICHN)*NW1(ICHN)/RW2**0.333333
              FZ=116.7*NW1(ICHN)*NW1(ICHN)/RZ**0.333333
              FT=116.7*NW1(ICHN)*NW1(ICHN)/RT**0.333333
              TAUE2=G*RHO2*CHNW*A2BAR*SENTR2/(2.0D0*(CHNW + A2BAR))
              TAUW2 = FW2*RHO2*ABS(U2)*U2/8.
              TAUZ  = FZ*RHO2*ABS(U2)*U2/8.
              TAUT  = FT*RHO2*ABS(U2)*U2/8.
              DENOM=(TAUT+TAUZ+2.0D0*TAUE2+2.*A2BAR*(TAUW2+TAUE2)/CHNW)/
     +          (G*RHO2*A2BAR)
            ENDIF
            DENOM=SZ-DENOM
            DX = (1.0 - FR2SQ)*DA2/DENOM
            X = X + DX
            PHEAD2 = PHEAD2 + DA2
          ENDDO
        ENDIF
  278   CONTINUE
C ADJUST Q2 BASED ON INTEGRATED LENGTH IN COMPARISON TO FL.
        IF(-X .LE. FL)THEN
          QMAX = Q2
        ELSE
          QMIN = Q2
        ENDIF
C IF INTEGRATED LENGTH AND DISCHARGE ARE WITHIN TOLERANCES, THEN
C STOP ITERATION.
        IF (ABS(FL + X) .LE. TOLX .AND.
     A    (QMAX-QMIN)      .LT. TOLQ1) GO TO 350
  300   CONTINUE 
      ENDDO      !QLOOP
C     WRITE(6,310)  IQ1
C 310 FORMAT (  ' IQ1 =', I5  )
      NPROG = 2
*      WRITE(*,*)'ARRESTED WEDGE: CULV2.3'
      Q2=-ABS(Q2)
      RETURN
  350 CONTINUE
C     WRITE(6,360) Q1, Q2
C 360 FORMAT(/     ' Q1 = ',F10.1,10X, 'Q2 = ',F10.1   /  /
C    1       11X, 'X', 13X, 'A', 12X, 'A1', 12X, 'A2',11X, 'LHS',12X,
C    2                  'F1', 12X, 'F2'     )
C     WRITE(6,390) XN,AN,A1N,A2N,FLHSN,F1N,F2 , IQ1,IX
C     IF(ITOE .EQ. 1)
C    AWRITE(6,390) XTOE,ATOE,A1TOE,A2TOE,FLHSTO,F1TOE,F2TOE
C     F2 = Q2/(B*A1*SQRT(EPS*A2*G))
C     WRITE(6 , 390)  X, A, A1, A2 , FLHS,  F2
C 390 FORMAT (1X, F13.2, 3F14.3, 3F14.4, 2I10 )
C IF (A2 .GT. 0.), THEN ARRESTED WEDGE WILL NOT EXIST.
C A2 IS ASSUMED ZERO WITHIN THE TOLERANCE BELOW
      IF((A1.LT.0.1).OR.ABS(CUL1-1.0D0).LT.1.0D-12)A1=0.0
      IF (A2N .LT.HEIGHT) GO TO 500
C     WRITE(6,450)
C 450 FORMAT(/' WEDGE TOE IS IN CULVERT.'/' THEREFORE AN ARRESTED WEDGE
C    AIS THE CORRECT FLOW REGIME.' / )
      NPROG = 2
*      WRITE(*,*)'ARRESTED WEDGE: CULV2.4'
      RETURN
  500 CONTINUE
C     WRITE(6,525)
C 525 FORMAT(/' CALCULATED LOWER LAYER DEPTH AT SOUTH END IS GREATER THA
C    BN ZERO.' /' THEREFORE AN ARRESTED WEDGE WILL NOT EXIST.'/)
      NPROG = 1
      RETURN
      END




