C     Last change:  CWM   8 Nov 1999    8:42 am
      SUBROUTINE INTER3(MATRIX,DSM,DDM,ENM,HDM,QSND)
*  3 INDEPENDENT VARIABLES
*  MATRIX IS VALID FOR NORTH DENSITY = 1.210 G/CC
      INTEGER*4 I, IM, J, JM, K, KM, L, MAXINT
      PARAMETER (IM=16)
      PARAMETER (JM=5)
      PARAMETER (KM=4)
      PARAMETER (MAXINT=7)
      REAL*8 MATRIX(IM+2,KM*JM+1),DD,DDF(KM),DDM,DS,DSM,ELN(JM)
      REAL*8 EN,ENM,HD,HDF(IM),HDM,QI(MAXINT),QSN(IM,JM,KM),QSND
*     INPUT VARIABLES RENAMED SO THEIR ORIGINAL VALUES WILL
*     REMAIN UNCHANGED WHEN PASSED BACK TO MAIN PROGRAM
      DS=DSM
      DD=DDM
      EN=ENM+4000.
      HD=HDM
*   LIMITATIONS OF INTERPOLATION PROGRAM
      IF(DS.LE.1.0)DS=1.0
      IF(DS.GE.1.205)DS=1.205
      IF(DD.LE.0.02)DD=0.02
      IF(DD.GE.0.124)DD=0.124
      IF(EN.LE.4191.0)EN=4191.0
      IF(EN.GE.4211.0)EN=4211.0
      IF(HD.LE.0.0)HD=0.0
      IF(HD.GE.3.5)HD=3.5
*  ASSIGN VALUES FOR ELEMENTS OF MATRICES
      DO 20 J=2,KM*JM+1
        K=INT(REAL(J+JM-2)/REAL(JM))
        DDF(K)=MATRIX(1,J)
        ELN(J-1+JM*(1-K))=MATRIX(2,J)
        DO 10 I=3,IM+2
          HDF(I-2)=MATRIX(I,1)
          QSN(I-2,J-1+JM*(1-K),K)=MATRIX(I,J)
10      CONTINUE
20    CONTINUE
*   INTERPOLATE QI WITH INDEPENDENT VARIABLES
      DO 50 K=2, KM
        IF((DDF(K-1).LE.DD) .AND. (DD.LE.DDF(K)))THEN
        DO 40 J=2, JM
          IF ((ELN(J-1).LE.EN) .AND. (EN.LE.ELN(J)))THEN
          DO 30 I=2,IM
            IF ((HDF(I-1).LE.HD) .AND. (HD.LE.HDF(I)))THEN
            CALL INTER(IM,HDF(I-1),HD,HDF(I),QSN(I-1,J-1,K-1),
     1      QI(1),QSN(I,J-1,K-1))
            CALL INTER(IM,HDF(I-1),HD,HDF(I),QSN(I-1,J,K-1),
     2      QI(2),QSN(I,J,K-1))
            CALL INTER(JM,ELN(J-1),EN,ELN(J),QI(1),QI(3),QI(2))
            CALL INTER(IM,HDF(I-1),HD,HDF(I),QSN(I-1,J-1,K),
     3      QI(4),QSN(I,J-1,K))
            CALL INTER(IM,HDF(I-1),HD,HDF(I),QSN(I-1,J,K),
     4      QI(5),QSN(I,J,K))
            CALL INTER(JM,ELN(J-1),EN,ELN(J),QI(4),QI(6),QI(5))
            CALL INTER(KM,DDF(K-1),DD,DDF(K),QI(3),QI(7),QI(6))
            GOTO 60
            ENDIF
30        CONTINUE
          ENDIF
40      CONTINUE
        ENDIF
50    CONTINUE
60    QSND=QI(MAXINT)
      RETURN
      END
