C     Last change:  CWM   8 Nov 1999    8:45 am
      SUBROUTINE SLOPE(AX1,AX2,AH1)
      INCLUDE 'INCLUDE.fi'
      INTEGER*4 IF
      REAL*8 AX1,AX2,U1,U2,F1SQ,F2SQ,U1BAR,U2BAR,TT5,RW1,RI1,FT
      REAL*8 TT6,RW2,RI2,RZ,REI,FI,TRY,FW1,FW2,ALPHA,BETA,AH1
      REAL*8 FZ,TAUI,TAUZ,TAUW1,TAUW2,TAUE1,TAUE2,T1,T2,RT1
      REAL*8 TAUT1,KAPPA
      U1 = Q1/(CHNW*A1BAR)
      U2 = Q2/(CHNW*A2BAR)
      F1SQ = U1*U1/(G*A1BAR*EPS)
      F2SQ = U2*U2/(G*A2BAR*EPS)
C ALLOCATE TOTAL RESISTANCE TO VARIOUS SHEAR SURFACES IN ORDER TO
C CONVERT FROM N TO F.
C     A1BAR = A1
C     A2BAR = A2
      IF(A1BAR.LE.0.0D0.OR.Q1.LE.0.0D0)THEN
        U1BAR=0.0D0
      ELSE
        U1BAR = Q1/(A1BAR*CHNW)
      ENDIF
      IF(A2BAR.LE.0.0D0.OR.ABS(Q2).LE.0.0D0)THEN
        U2BAR=0.0D0
      ELSE
        U2BAR = Q2/(A2BAR*CHNW)
      ENDIF
      IF(U1BAR.LE.0.0D0)THEN
        TT5=1.0D0
      ELSE
        TT5 = ((U1BAR-U2BAR)/U1BAR)** 1.5
      ENDIF
      IF(ABS(Q1).GT.0.0D0)THEN
        IF(TOTHEAD1.LT.HEIGHT)THEN
          RW1=CHNW*A1BAR/(2.*A1BAR+CHNW*TT1*TT5)
          RI1=CHNW*A1BAR/(2.*A1BAR/(TT1*TT5)+CHNW)
          RT1=0.0D0
        ELSE
          RW1=A1BAR/(TT8+TT1*TT5+2.0D0*A1BAR/CHNW)
          RT1=A1BAR/(1.0D0+TT5/TT7+2*A1BAR/(TT8*CHNW))
          RI1=A1BAR/((TT7+2*A1BAR/(CHNW*TT1))/TT5+1.0D0)
        ENDIF
      ELSE
        RW1=0.0D0
        RT1=0.0D0
        RI1=A1BAR
      ENDIF
      IF(ABS(U2BAR).LE. 1.0D-15)THEN
        TT6 = 1.0D0
      ELSE
        TT6 =(-(U1BAR-U2BAR)/U2BAR)**1.5
      ENDIF
C     WRITE(*,*)U1BAR,'=U1BAR  ',U2BAR,'=U2BAR  ',TT5,'=TT5  ',
C    - TT6,'=TT6'
      IF(ABS(Q2).GT.0.0D0)THEN
        RW2=CHNW*A2BAR/(2.*A2BAR+CHNW*(TT2*TT6+TT3))
        RI2=CHNW*A2BAR/(2.*A2BAR/(TT2*TT6)+CHNW*(1.+TT4/TT6))
        RZ=CHNW*A2BAR/(2.*A2BAR/TT3+CHNW*(TT6/TT4+1.))
      ELSE
        RW2=0.0D0
        RI2=A2BAR
        RZ=0.0D0
      ENDIF
      REI=ABS(U1BAR*RI1 - U2BAR*RI2)*4./0.00002*(RHO1+RHO2)/2.0D0
      FI = 0.316/REI**0.25
C IF(REI .GT. 100000.), TRIAL AND ERROR IS NEEDED TO OBTAIN FI.
      IF(REI.GT.100000.)THEN
        DO IF = 1,25
          TRY=FI
          FI = 1.0D0/(2.0D0*LOG10(REI*FI**0.5)-0.8)**2
          IF(ABS((TRY-FI)/FI) .LE. 0.0001) GO TO 180 !EXIT
        ENDDO
 180     CONTINUE
      ENDIF
C     WRITE(6,183) IF
C 183 FORMAT(1X, 'IF =',  I5  )
      IF(RW1.LE.0.0D0)THEN
        FW1=0.0D0
      ELSE
        FW1 = 116.7*NW1(ICHN)*NW1(ICHN)/RW1**0.333333
      ENDIF
      IF(RT1.LE.0.0D0)THEN
        FT=0.0D0
      ELSE
        FT = 116.7*NT(ICHN)*NT(ICHN)/RT1**.333333
      ENDIF
      IF (RW2.EQ.0.0D0) THEN
        FW2=0.0D0
      ELSE
        FW2 = 116.7*NW2(ICHN)*NW2(ICHN)/RW2**0.333333
      END IF
      IF(RZ.NE.0.0D0)THEN
        FZ = 116.7*NZ(ICHN)*NZ(ICHN)/RZ**0.333333
      ELSE
        FZ = 0.0D0
      ENDIF
      TAUI=FI*0.5*(RHO1+RHO2)*(U1-U2)**2*0.125D0
      TAUZ=-1.0D0*ABS(FZ*RHO2*ABS(U2)*U2*0.125D0)
      TAUT1=    FT *RHO1*ABS(U1)*U1*0.125D0
      TAUW1=    FW1*RHO1*ABS(U1)*U1*0.125D0
      TAUW2=-1.0D0*ABS(FW2*RHO2*ABS(U2)*U2*0.125D0)
      TAUE1 = 0.
      TAUE2 = 0.
      IF(-X .LE. FL)THEN
        IF(TOTHEAD1.GE.HEIGHT)THEN
          TAUE1 = G*RHO1*CHNW*A1BAR*SENTR1/(2.0D0*(CHNW+A1BAR))
        ELSE
          TAUE1 = G*RHO1*CHNW*A1BAR*SENTR1/(CHNW+2.*A1BAR)
        ENDIF
        TAUE2 =-G*RHO2*CHNW*A2BAR*SENTR2/(2.0D0*(CHNW + A2BAR))
      ENDIF
      IF(TOTHEAD1.LE.HEIGHT)THEN
        T1=(TAUI+TAUE1+2.*A1BAR*(TAUE1+TAUW1)/CHNW)/(G*RHO1*A1BAR)
      ELSE
        T1=(TAUT1+TAUI+2.*TAUE1+2.*A1BAR*
     +    (TAUE1+TAUW1)/CHNW)/(G*RHO1*A1BAR)
      ENDIF
      T2=(TAUZ+2.*TAUE2-TAUI+2.*A2BAR*(TAUE2+TAUW2)/CHNW)/(G*RHO2*A2BAR)
      DENOM=F1SQ+F2SQ-EPS*F1SQ*F2SQ-1.
      IF (ABS(DENOM) .GT. 1.0E-35) GO TO 300
      NSTOP = 1
      RETURN
  300 CONTINUE
      ALPHA=(1./EPS-F2SQ)*T1-T2/EPS+F2SQ*SZ
      BETA=(1.-1./EPS)*T1+(1./EPS-F1SQ)*T2+(F1SQ-1.)*SZ
      IF(TOTHEAD1.GE.HEIGHT)THEN
        KAPPA=F1SQ+F2SQ-EPS*F1SQ-1.0D0
        AX1=(ALPHA+(1.0D0-F2SQ)*(ALPHA+BETA)/KAPPA)/DENOM
        AX2=(BETA-(1.0D0-EPS)*F1SQ*(ALPHA+BETA)/KAPPA)/DENOM
        AH1=(ALPHA+BETA)/KAPPA
      ELSE
        AX1=ALPHA/DENOM
        AX2=BETA/DENOM
        AH1=(ALPHA+BETA)/DENOM
      ENDIF
c      IF (PRINTIT) THEN
C        NCOUNT=NCOUNT+1
C        WRITE(17,*)' COUNT ',NCOUNT
C        WRITE(17,*)' U1BAR ',U1BAR,' U2BAR ',U2BAR,'   TT5 ',TT5,
C     A   ' RW1   ',RW1
C        WRITE(17,*)' RI1   ',RI1  ,'   TT6 ',TT6  ,'   RW2 ',RW2  ,
C     A   ' RT1   ',RT1
C        WRITE(17,*)' RI2   ',RI2  ,'    RZ ',RZ   ,'   REI ',REI  ,
C     A   '  FI   ',FI
C        WRITE(17,*)'  FI   ',FI   ,'   FW1 ',FW1  ,'   FW2 ',FW2  ,
C     A   '  FZ   ',FZ
C        WRITE(17,*)' TAUI  ',TAUI ,'  TAUZ ',TAUZ ,' TAUT1 ',TAUT1,
C     A   ' TAUW1 ',TAUW1
C        WRITE(17,*)' TAUW2 ',TAUE1,' TAUE1 ',TAUE2,' TAUE2 ',T1,
C     A   '    T1 ',T1
C        WRITE(17,*)'    T2 ',T2   ,'   AX1 ',AX1  ,'   AX2 ',AX2,
C     A   '    Q1 ',Q1
C        WRITE(17,*)'    Q2 ',Q2   ,' A1BAR ',A1BAR,' A2BAR ',A2BAR
c      END IF
      RETURN
      END











